/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.CategoriaClaseDAO;
import com.rjconsultores.ventaboletos.entidad.CategoriaClase;
import com.rjconsultores.ventaboletos.entidad.CategoriaCtrl;
import com.rjconsultores.ventaboletos.service.CategoriaClaseService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

/**
 *
 * @author Administrador
 */
@Service("categoriaClaseService")
public class CategoriaClaseServiceImpl implements CategoriaClaseService {

    @Autowired
    private CategoriaClaseDAO categoriaClaseDAO;

    public List<CategoriaClase> obtenerTodos() {
        return categoriaClaseDAO.obtenerTodos();
    }

    public CategoriaClase obtenerID(Integer id) {
        return categoriaClaseDAO.obtenerID(id);
    }

    @Transactional
    public CategoriaClase suscribir(CategoriaClase entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return categoriaClaseDAO.suscribir(entidad);
    }

    @Transactional
    public CategoriaClase actualizacion(CategoriaClase entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return categoriaClaseDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(CategoriaClase entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);


        categoriaClaseDAO.actualizacion(entidad);
    }

    public CategoriaClase busquedaPoCategoriaCtrl(CategoriaCtrl categoriaCtrl) {
        return categoriaClaseDAO.busquedaPoCategoriaCtrl(categoriaCtrl);
    }
    
    @Override
	@Transactional
	public void actualizacionAuditagem(List<CategoriaClase> lsCategoriaClase) {
		for (CategoriaClase cc : lsCategoriaClase) {
			if(Boolean.TRUE.equals(cc.getActivo())) {
				continue;
			}
			categoriaClaseDAO.actualizacion(cc);
		}		
	}
}
